VampPluginSDK 2.1

- Main Page
- Namespaces
- Classes
- Files
- Directories

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Vamp::PluginHostAdapter Class Reference

PluginHostAdapter is a wrapper class that a Vamp host can use to make the C-language VampPluginDescriptor object appear as a C++ Vamp::Plugin object. More...

`#include <vamp-hostsdk/PluginHostAdapter.h>`

Inheritance diagram for Vamp::PluginHostAdapter:
[legend]

List of all members.

## Public Types
enum | InputDomain { TimeDomain, FrequencyDomain }
typedef std::vector < OutputDescriptor > | OutputList
typedef std::vector< Feature > | FeatureList
typedef std::map< int, FeatureList > | FeatureSet
typedef std::vector < ParameterDescriptor > | ParameterList
typedef std::vector< std::string > | ProgramList
## Public Member Functions
| PluginHostAdapter (const VampPluginDescriptor *descriptor, float inputSampleRate)
virtual | ~PluginHostAdapter ()
bool | initialise (size_t channels, size_t stepSize, size_t blockSize)
| Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames).
void | reset ()
| Reset the plugin after use, to prepare it for another clean run.
InputDomain | getInputDomain () const
| Get the plugin's required input domain.
unsigned int | getVampApiVersion () const
| Get the Vamp API compatibility level of the plugin.
std::string | getIdentifier () const
| Get the computer-usable name of the plugin.
std::string | getName () const
| Get a human-readable name or title of the plugin.
std::string | getDescription () const
| Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name".
std::string | getMaker () const
| Get the name of the author or vendor of the plugin in human-readable form.
int | getPluginVersion () const
| Get the version number of the plugin.
std::string | getCopyright () const
| Get the copyright statement or licensing summary for the plugin.
ParameterList | getParameterDescriptors () const
| Get the controllable parameters of this plugin.
float | getParameter (std::string) const
| Get the value of a named parameter.
void | setParameter (std::string, float)
| Set a named parameter.
ProgramList | getPrograms () const
| Get the program settings available in this plugin.
std::string | getCurrentProgram () const
| Get the current program.
void | selectProgram (std::string)
| Select a program.
size_t | getPreferredStepSize () const
| Get the preferred step size (window increment -- the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin.
size_t | getPreferredBlockSize () const
| Get the preferred block size (window size -- the number of sample frames passed in each block to the process() function).
size_t | getMinChannelCount () const
| Get the minimum supported number of input channels.
size_t | getMaxChannelCount () const
| Get the maximum supported number of input channels.
OutputList | getOutputDescriptors () const
| Get the outputs of this plugin.
FeatureSet | process (const float *const *inputBuffers, RealTime timestamp)
| Process a single block of input data.
FeatureSet | getRemainingFeatures ()
| After all blocks have been processed, calculate and return any remaining features derived from the complete input.
virtual std::string | getType () const
| Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase.
## Static Public Member Functions
static std::vector< std::string > | getPluginPath ()
## Protected Member Functions
void | convertFeatures (VampFeatureList *, FeatureSet &)
## Protected Attributes
const VampPluginDescriptor * | m_descriptor
VampPluginHandle | m_handle
float | m_inputSampleRate

## Detailed Description

PluginHostAdapter is a wrapper class that a Vamp host can use to make the C-language VampPluginDescriptor object appear as a C++ Vamp::Plugin object.

The Vamp API is defined in vamp/vamp.h as a C API. The C++ objects used for convenience by plugins and hosts actually communicate using the C low-level API, but the details of this communication are handled seamlessly by the Vamp SDK implementation provided the plugin and host use the proper C++ wrapper objects.

See also PluginAdapter, the plugin-side wrapper that makes a C++ plugin object available using the C query API.

Definition at line 68 of file PluginHostAdapter.h.

## Member Typedef Documentation

typedef std::vector<OutputDescriptor> Vamp::Plugin::OutputList`[inherited]`

Definition at line 327 of file vamp-sdk/Plugin.h.

typedef std::vector<Feature> Vamp::Plugin::FeatureList`[inherited]`

Definition at line 385 of file vamp-sdk/Plugin.h.

typedef std::map<int, FeatureList> Vamp::Plugin::FeatureSet`[inherited]`

Definition at line 387 of file vamp-sdk/Plugin.h.

typedef std::vector<ParameterDescriptor> Vamp::PluginBase::ParameterList`[inherited]`

Definition at line 203 of file vamp-sdk/PluginBase.h.

typedef std::vector<std::string> Vamp::PluginBase::ProgramList`[inherited]`

Definition at line 225 of file vamp-sdk/PluginBase.h.

## Member Enumeration Documentation

enum Vamp::Plugin::InputDomain`[inherited]`

Enumerator:

  TimeDomain |
  FrequencyDomain |

Definition at line 152 of file vamp-sdk/Plugin.h.

## Constructor & Destructor Documentation

Vamp::PluginHostAdapter::PluginHostAdapter | ( | const VampPluginDescriptor * | descriptor,
|  | float | inputSampleRate
| ) |  |

virtual Vamp::PluginHostAdapter::~PluginHostAdapter | ( |  | ) | `[virtual]`

## Member Function Documentation

static std::vector<std::string> Vamp::PluginHostAdapter::getPluginPath | ( |  | ) | `[static]`

bool Vamp::PluginHostAdapter::initialise | ( | size_t | inputChannels,
|  | size_t | stepSize,
|  | size_t | blockSize
| ) |  | `[virtual]`

Initialise a plugin to prepare it for use with the given number of input channels, step size (window increment, in sample frames) and block size (window size, in sample frames).

The input sample rate should have been already specified at construction time.

Return true for successful initialisation, false if the number of input channels, step size and/or block size cannot be supported.

Implements Vamp::Plugin.

void Vamp::PluginHostAdapter::reset | ( |  | ) | `[virtual]`

Reset the plugin after use, to prepare it for another clean run.

Not called for the first initialisation (i.e. initialise must also do a reset).

Implements Vamp::Plugin.

InputDomain Vamp::PluginHostAdapter::getInputDomain | ( |  | ) | const`[virtual]`

Get the plugin's required input domain.

If this is TimeDomain, the samples provided to the process() function (below) will be in the time domain, as for a traditional audio processing plugin.

If this is FrequencyDomain, the host will carry out a windowed FFT of size equal to the negotiated block size on the data before passing the frequency bin data in to process(). The input data for the FFT will be rotated so as to place the origin in the centre of the block. The plugin does not get to choose the window type -- the host will either let the user do so, or will use a Hanning window.

Implements Vamp::Plugin.

unsigned int Vamp::PluginHostAdapter::getVampApiVersion | ( |  | ) | const`[virtual]`

Get the Vamp API compatibility level of the plugin.

Reimplemented from Vamp::PluginBase.

std::string Vamp::PluginHostAdapter::getIdentifier | ( |  | ) | const`[virtual]`

Get the computer-usable name of the plugin.

This should be reasonably short and contain no whitespace or punctuation characters. It may only contain the characters [a-zA-Z0-9_-]. This is the authoritative way for a program to identify a plugin within a given library.

This text may be visible to the user, but it should not be the main text used to identify a plugin to the user (that will be the name, below).

Example: "zero_crossings"

Implements Vamp::PluginBase.

std::string Vamp::PluginHostAdapter::getName | ( |  | ) | const`[virtual]`

Get a human-readable name or title of the plugin.

This should be brief and self-contained, as it may be used to identify the plugin to the user in isolation (i.e. without also showing the plugin's "identifier").

Example: "Zero Crossings"

Implements Vamp::PluginBase.

std::string Vamp::PluginHostAdapter::getDescription | ( |  | ) | const`[virtual]`

Get a human-readable description for the plugin, typically a line of text that may optionally be displayed in addition to the plugin's "name".

May be empty if the name has said it all already.

Example: "Detect and count zero crossing points"

Implements Vamp::PluginBase.

std::string Vamp::PluginHostAdapter::getMaker | ( |  | ) | const`[virtual]`

Get the name of the author or vendor of the plugin in human-readable form.

This should be a short identifying text, as it may be used to label plugins from the same source in a menu or similar.

Implements Vamp::PluginBase.

int Vamp::PluginHostAdapter::getPluginVersion | ( |  | ) | const`[virtual]`

Get the version number of the plugin.

Implements Vamp::PluginBase.

std::string Vamp::PluginHostAdapter::getCopyright | ( |  | ) | const`[virtual]`

Get the copyright statement or licensing summary for the plugin.

This can be an informative text, without the same presentation constraints as mentioned for getMaker above.

Implements Vamp::PluginBase.

ParameterList Vamp::PluginHostAdapter::getParameterDescriptors | ( |  | ) | const`[virtual]`

Get the controllable parameters of this plugin.

Reimplemented from Vamp::PluginBase.

float Vamp::PluginHostAdapter::getParameter | ( | std::string |  | ) | const`[virtual]`

Get the value of a named parameter.

The argument is the identifier field from that parameter's descriptor.

Reimplemented from Vamp::PluginBase.

void Vamp::PluginHostAdapter::setParameter | ( | std::string | ,
|  | float |
| ) |  | `[virtual]`

Set a named parameter.

The first argument is the identifier field from that parameter's descriptor.

Reimplemented from Vamp::PluginBase.

ProgramList Vamp::PluginHostAdapter::getPrograms | ( |  | ) | const`[virtual]`

Get the program settings available in this plugin.

A program is a named shorthand for a set of parameter values; changing the program may cause the plugin to alter the values of its published parameters (and/or non-public internal processing parameters). The host should re-read the plugin's parameter values after setting a new program.

The programs must have unique names.

Reimplemented from Vamp::PluginBase.

std::string Vamp::PluginHostAdapter::getCurrentProgram | ( |  | ) | const`[virtual]`

Get the current program.

Reimplemented from Vamp::PluginBase.

void Vamp::PluginHostAdapter::selectProgram | ( | std::string |  | ) | `[virtual]`

Select a program.

(If the given program name is not one of the available programs, do nothing.)

Reimplemented from Vamp::PluginBase.

size_t Vamp::PluginHostAdapter::getPreferredStepSize | ( |  | ) | const`[virtual]`

Get the preferred step size (window increment -- the distance in sample frames between the start frames of consecutive blocks passed to the process() function) for the plugin.

This should be called before initialise().

A plugin may return 0 if it has no particular interest in the step size. In this case, the host should make the step size equal to the block size if the plugin is accepting input in the time domain. If the plugin is accepting input in the frequency domain, the host may use any step size. The final step size will be set in the initialise() call.

Reimplemented from Vamp::Plugin.

size_t Vamp::PluginHostAdapter::getPreferredBlockSize | ( |  | ) | const`[virtual]`

Get the preferred block size (window size -- the number of sample frames passed in each block to the process() function).

This should be called before initialise().

A plugin that can handle any block size may return 0. The final block size will be set in the initialise() call.

Reimplemented from Vamp::Plugin.

size_t Vamp::PluginHostAdapter::getMinChannelCount | ( |  | ) | const`[virtual]`

Get the minimum supported number of input channels.

Reimplemented from Vamp::Plugin.

size_t Vamp::PluginHostAdapter::getMaxChannelCount | ( |  | ) | const`[virtual]`

Get the maximum supported number of input channels.

Reimplemented from Vamp::Plugin.

OutputList Vamp::PluginHostAdapter::getOutputDescriptors | ( |  | ) | const`[virtual]`

Get the outputs of this plugin.

An output's index in this list is used as its numeric index when looking it up in the FeatureSet returned from the process() call.

Implements Vamp::Plugin.

FeatureSet Vamp::PluginHostAdapter::process | ( | const float *const * | inputBuffers,
|  | RealTime | timestamp
| ) |  | `[virtual]`

Process a single block of input data.

If the plugin's inputDomain is TimeDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize consecutive audio samples (the host will zero-pad as necessary). The timestamp in this case will be the real time in seconds of the start of the supplied block of samples.

If the plugin's inputDomain is FrequencyDomain, inputBuffers will point to one array of floats per input channel, and each of these arrays will contain blockSize/2+1 consecutive pairs of real and imaginary component floats corresponding to bins 0..(blockSize/2) of the FFT output. That is, bin 0 (the first pair of floats) contains the DC output, up to bin blockSize/2 which contains the Nyquist-frequency output. There will therefore be blockSize+2 floats per channel in total. The timestamp will be the real time in seconds of the centre of the FFT input window (i.e. the very first block passed to process might contain the FFT of half a block of zero samples and the first half-block of the actual data, with a timestamp of zero).

Return any features that have become available after this process call. (These do not necessarily have to fall within the process block, except for OneSamplePerStep outputs.)

Implements Vamp::Plugin.

FeatureSet Vamp::PluginHostAdapter::getRemainingFeatures | ( |  | ) | `[virtual]`

After all blocks have been processed, calculate and return any remaining features derived from the complete input.

Implements Vamp::Plugin.

void Vamp::PluginHostAdapter::convertFeatures | ( | VampFeatureList * | ,
|  | FeatureSet & |
| ) |  | `[protected]`

virtual std::string Vamp::Plugin::getType | ( |  | ) | const`[inline, virtual, inherited]`

Used to distinguish between Vamp::Plugin and other potential sibling subclasses of PluginBase.

Do not reimplement this function in your subclass.

Implements Vamp::PluginBase.

Definition at line 430 of file vamp-sdk/Plugin.h.

## Member Data Documentation

const VampPluginDescriptor* Vamp::PluginHostAdapter::m_descriptor`[protected]`

Definition at line 113 of file PluginHostAdapter.h.

VampPluginHandle Vamp::PluginHostAdapter::m_handle`[protected]`

Definition at line 114 of file PluginHostAdapter.h.

float Vamp::Plugin::m_inputSampleRate`[protected, inherited]`

Definition at line 436 of file vamp-sdk/Plugin.h.

Referenced by FixedTempoEstimator::D::assembleFeatures(), FixedTempoEstimator::D::calculate(), FixedTempoEstimator::D::getOutputDescriptors(), ZeroCrossing::getOutputDescriptors(), PercussionOnsetDetector::getOutputDescriptors(), AmplitudeFollower::initialise(), FixedTempoEstimator::D::initialise(), FixedTempoEstimator::D::lag2tempo(), ZeroCrossing::process(), SpectralCentroid::process(), PercussionOnsetDetector::process(), and FixedTempoEstimator::D::tempo2lag().

The documentation for this class was generated from the following file:

- PluginHostAdapter.h